-- PROGRAMA DE TEST DE MOTOR DC (preparat per 8 velocitats)
--	Inicialitza aturat
--	Accions
--		+ -> augmenta vel
--		- -> disminueix velocitat
--		ASCII -> (suposant nmero, sino el que surti!)
--		i -> inicialitzar (aturat)

.CON aturat = 3;

.DEF tmp = R16;
.DEF vel = R20;
.DEF cas = R21;

.org 0;
	RJMP main;
.org 15;
	RJMP isrRxD ;
	
.org 32;
main:	RCALL inici7segm;
	LDI tmp, 0x10C;		--Control usart: interrupci RxD, presc=12 (115200bauds-24MHz)
	OUT uart0ctrl, tmp;
	LDI vel, aturat;
	OUT PWM0A, vel;		--Inicialitzat a aturat (valor 
	LDI tmp, 0x9F3;
	OUT PWM0ctrl, tmp;	--Inicialitzat PWM0: 1001 1111 0011 (en + 499) (divisor per 500)
	LDI vel, aturat;
	LDI cas, 0;
	SEI;			--Activaci interrupts
retorn: CPI cas, 0;
	BRZE retorn;
	OUT PORTB, cas;
	RCALL a7segm;
	RCALL tractarCas;
	LDI cas, 0;
	RJMP retorn;
	NOP;
		
.ORG 100;
tractarCas: CPI cas, 0x2B;	--'+'
	BREQ esMes;
	CPI cas, 0x2D;	--'-'
	BREQ esMenys;
	CPI cas, 0x61;	--'a'
	BREQ esA;
	MOV vel, cas;
	SUBI vel, 0x30;
	RJMP fi;
esMes:	INC vel;
	RJMP fi;
esMenys: DEC vel;
	RJMP fi;
esA:	LDI vel, aturat;
fi:	OUT PWM0A, vel;
	OUT PORTB, vel;		--enviar a leds
	RET;
	NOP;

--Rutina d'interrupci de recepci
.org 200;
a7segm: MOV tmp, cas;
	ANDI tmp, 0x00F;
	LDI X, hex2ss0;
	ADD X, tmp;
	LPM tmp, X;
	OUT SS0, tmp;
	SWAP cas;
	MOV tmp, cas;
	ANDI tmp, 0x00F;
	LDI X, hex2ss0;
	ADD X, tmp;
	LPM tmp, X;
	OUT SS1, tmp;
	SWAP cas;
	MOV tmp, cas;
	ANDI tmp, 0x00F;
	LDI X, hex2ss0;
	ADD X, tmp;
	LPM tmp, X;
	OUT SS2, tmp;
	SWAP cas;
	RET;
	NOP;

--Rutina d'interrupci de recepci
.org 300;
isrRxD: IN cas, uart0rxd;		--rebre
	RETI;
	NOP;

.org 1500;
inici7segm:LDI X, hex2ss0;
	LPM tmp, X;
	OUT SS0, tmp;
	OUT SS1, tmp;
	OUT SS2, tmp;
	OUT SS3, tmp;
	RET;
	NOP;

.org 1600;
hex2ss0: .dw 0x3F;
hex2ss1: .dw 0x6;
hex2ss2: .dw 0x5B;
hex2ss3: .dw 0x4F;
hex2ss4: .dw 0x66;
hex2ss5: .dw 0x6D;
hex2ss6: .dw 0x7D;
hex2ss7: .dw 0x7;
hex2ss8: .dw 0x7F;
hex2ss9: .dw 0x67;
hex2ss10: .dw 0x5F;
hex2ss11: .dw 0x7C;
hex2ss12: .dw 0x58;
hex2ss13: .dw 0x5E;
hex2ss14: .dw 0x79;
hex2ss15: .dw 0x71;
hex2ss16: .dw 0x80;