--  Dos sensors FTOC d'entrada

.con CR = 0x0A;
.con LF = 0x0D;
.con PUNT = 0x2E;

.con posftoc0 = 0x0;
.con posftoc1 = 0x1;

.def tmp = R20;
.def tmpi = R21;
.def cas = R0;
.def dada = R1;

.org 0;
	RJMP main;	     	->a main
.org 3;
	RJMP isrExt1dw ;	-> Noms es fa servir per comprovar funcionament
.org 16;
	RJMP isrFTOC0 ;
	RJMP isrFTOC1 ;
.org 32;
main:	LDI X, hex2ssU;
	LPM tmp, X;
	OUT SS0, tmp;
	OUT SS1, tmp;
	OUT SS2, tmp;
	OUT SS3, tmp;
	LDI tmp,0x0004;		-> Ctrl.Int.Ext. Noms per comprovar funcionament
	OUT ext0ctrl, tmp;
	LDI tmp,0xC7D;		-> Ctrl.Ftoc. -> 1100 01111101
	OUT FTOC0ctrl, tmp;		ADDRCTRL_FTOC0
	OUT FTOC1ctrl, tmp;		ADDRCTRL_FTOC1
	LDI tmp,0x000C;		-> Ctrl.Uart:
	OUT uart0ctrl, tmp;		No interrupci, presc=12 (115200bauds-24MHz)
	SEI;			-> Activaci interrupcions (BSET 0x7)	
retorn: LDI cas, 0;
test: 	CPI cas, 0;
	BREQ test;
 	CPI cas, 1;
	BREQ cas1;
-- 	CPI cas, 2
--	BREQ cas2
	RJMP retorn;
cas1:	LDS dada, posftoc0;	-> Agafar dada sensor0 de memria dades
	RCALL enviarDadaSS0;
	RCALL enviarDadaUart;	...compte: dada arriba amb 1 swap!
	RJMP retorn;
cas2:	LDS dada, posftoc1;	-> Agafar dada sensor1 de memria dades
	RCALL enviarDadaSS1;
	RCALL enviarDadaUart;	...compte: dada arriba amb 1 swap!
	RJMP retorn;
	NOP;

.org 100;
enviarDadaSS0: LDI X, 0x00F;	-> Treure dada sensor0 per SS
	AND X, dada;
	ADDI X, hex2ss0;
	LPM tmp, X;
	OUT SS0, tmp;
	SWAP dada;
	LDI X, 0x00F;
	AND X, dada;
	ADDI X, hex2ss0;
	LPM tmp, X;
	OUT SS1, tmp;
	RET;
.org 125;
enviarDadaSS1: LDI X, 0x00F;	-> Treure dada sensor1 per SS
	AND X, dada;
	ADDI X, hex2ss0;
	LPM tmp, X;
	OUT SS2, tmp;
	SWAP dada;
	LDI X, 0x00F;
	AND X, dada;
	ADDI X, hex2ss0;
	LPM tmp, X;
	OUT SS3, tmp;
	RET;

.org 150;
enviarDadaUart: NOP;	...compte: dada arriba amb 1 swap!
noBuit0: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit0;
	MOV tmp, cas;		-> Treure cas (1 o 2)
	ADDI tmp, 0x30;
	OUT uart0txd, tmp;
noBuit1: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit1;
	LDI tmp, PUNT;		-> Treure punt
	OUT uart0txd, tmp;
noBuit2: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit2;
	LDI tmp, 0x00F;		-> Enviar bit ms significatiu
	AND tmp, dada;
	ADDI tmp, 0x30;
	OUT uart0txd, tmp;
noBuit3: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit3;
	SWAP dada;		-> Enviar bit menys significatiu
	SWAP dada;
	LDI tmp, 0x00F;
	AND tmp, dada;
	ADDI tmp, 0x30;
	OUT uart0txd, tmp;
noBuit4: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit4;
	LDI tmp, LF;		-> Treure LF
	OUT uart0txd, tmp;
noBuit5: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit5;
	LDI tmp, CR;		-> Treure CR
	OUT uart0txd, tmp;	
	RET;
	NOP;

----Rutina d'interrupci isrExt1down (polsador de prova: envia slides a leds)
.org 500;
isrExt1dw: IN tmpi, PORTA;	-> Agafar slides
	OUT PORTB, tmpi;	-> Enviar a leds
	RETI;
	NOP;

--Rutina d'interrupci isrFTOC0
.org 525;
isrFTOC0: LDI cas, 1;
	IN tmpi, FTOC0;		->S'agafa dada de ftoc
--	OUT uart0txd, tmpi
	STS posftoc0, tmpi;
	RETI;
	NOP;

--Rutina d'interrupci isrFTOC1
.org 550;
isrFTOC1: LDI cas, 2;
	IN tmpi, FTOC1;		->S'agafa dada de ftoc
--	OUT uart0txd, tmpi
	STS posftoc1, tmpi;
	RETI;
	NOP;

.org 2000;	-- codis set-segments
hex2ss0: .dw 0x3F;
hex2ss1: .dw 0x6;
hex2ss2: .dw 0x5B;
hex2ss3: .dw 0x4F;
hex2ss4: .dw 0x66;
hex2ss5: .dw 0x6D;
hex2ss6: .dw 0x7D;
hex2ss7: .dw 0x7;
hex2ss8: .dw 0x7F;
hex2ss9: .dw 0x67;
hex2ssA: .dw 0x5F;
hex2ssB: .dw 0x7C;
hex2ssC: .dw 0x58;
hex2ssD: .dw 0x5E;
hex2ssE: .dw 0x79;
hex2ssF: .dw 0x71;
hex2ssPD: .dw 0x80;
hex2ssU: .dw 0x3E;
