--  Dos sensors FTOC d'entrada

.con posftoc0 = 0x0;
.con posftoc1 = 0x1;

.def tmp = R20;
.def tmpi = R21;
.def cas = R0;
.def sensor = R2;
.def dada = R1;
.def bitss0 = R10;
.def bitss1 = R11;
.def bituart0 = R12;
.def bituart1 = R13;

.org 0;
	RJMP main;	     	->a main
.org 3;
	RJMP isrExt1dw ;	-> Noms es fa servir per comprovar funcionament
.org 16;
	RJMP isrFTOC0 ;
	RJMP isrFTOC1 ;
.org 32;
main:	LDI X, hex2ssU;
	LPM tmp, X;
	OUT SS0, tmp;
	OUT SS1, tmp;
	OUT SS2, tmp;
	OUT SS3, tmp;
	LDI tmp,0x0004;		-> Ctrl.Int.Ext. Noms per comprovar funcionament
	OUT ext0ctrl, tmp;
	LDI tmp,0xC7D;		-> Ctrl.Ftoc. -> 1100 01111101
	OUT FTOC0ctrl, tmp;		ADDRCTRL_FTOC0
	OUT FTOC1ctrl, tmp;		ADDRCTRL_FTOC1
	LDI tmp,0x000C;		-> Ctrl.Uart:
	OUT uart0ctrl, tmp;		No interrupci, presc=12 (115200bauds-24MHz)
	SEI;			-> Activaci interrupcions (BSET 0x7)	
retorn: LDI cas, 0;
test: 	MOV tmp, cas;
	ANDI tmp, 0x001;
	BRNZ cas1;
 	MOV tmp, cas;
	ANDI tmp, 0x002;
	BRNZ cas2;
		-> Es poden anar posant altres sensors (cada sensor un bit diferent)
		;ANDI tmp, 0x004
		;BRNZ cas3
		;...
	ANDI cas, 0xFFC;	-> Elimina tots els casos a no considerar
	RJMP test;
cas1:	LDI sensor, 0x30;
	LDS dada, posftoc0;	-> Agafar dada sensor0 de memria dades
	RCALL tractarDada;
	OUT SS0, bitss0;
	OUT SS1, bitss1;
	RCALL enviarDadaUart;
	ANDI cas, 0xFFE;	-> Elimina el cas tractat
	RJMP test;
cas2:	LDI sensor, 0x31;
	LDS dada, posftoc1;	-> Agafar dada sensor1 de memria dades
	RCALL tractarDada;
	OUT SS2, bitss0;
	OUT SS3, bitss1;
	RCALL enviarDadaUart;
	ANDI cas, 0xFFD;	-> Elimina el cas tractat
	RJMP test;
	NOP;

.org 100;
tractarDada: LDI X, 0x00F;	-> Tractament per SS bit menys significatiu
	AND X, dada;
	ADDI X, hex2ss0;
	LPM bitss0, X;
	LDI X, 0x00F;		-> Tractament per UART
	AND X, dada;
	ADDI X, ascii0;
	LPM bituart0, X;
	SWAP dada;
	LDI X, 0x00F;		-> Tractament per SS bit ms significatiu
	AND X, dada;
	ADDI X, hex2ss0;
	LPM bitss1, X;
	LDI X, 0x00F;		-> Tractament per UART
	AND X, dada;
	ADDI X, ascii0;
	LPM bituart1, X;
	RET;

.org 150;
enviarDadaUart: NOP;
noBuit0: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit0;
	OUT uart0txd, sensor;	-> Treure sensor (0 o 1 o ...)
noBuit1: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit1;
	LDI tmp, 0x2E;		-> Treure punt
	OUT uart0txd, tmp;
noBuit2: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit2;
	OUT uart0txd, bituart1;	-> Bit ms significatiu
noBuit3: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit3;
	OUT uart0txd, bituart0;	-> Bit menys significatiu
noBuit4: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit4;
	LDI tmp, 0x0D;		-> Treure CR
	OUT uart0txd, tmp;
noBuit5: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit5;
	LDI tmp, 0x0A;		-> Treure LF
	OUT uart0txd, tmp;	
	RET;
	NOP;

----Rutina d'interrupci isrExt1down (polsador de prova: envia slides a leds)
.org 500;
isrExt1dw: IN tmpi, PORTA;	-> Agafar slides
	OUT PORTB, tmpi;	-> Enviar a leds
	RETI;
	NOP;

--Rutina d'interrupci isrFTOC0
.org 525;
isrFTOC0: LDI cas, 1;
	IN tmpi, FTOC0;		->S'agafa dada de ftoc
	STS posftoc0, tmpi;
	RETI;
	NOP;

--Rutina d'interrupci isrFTOC1
.org 550;
isrFTOC1: LDI cas, 2;
	IN tmpi, FTOC1;		->S'agafa dada de ftoc
	STS posftoc1, tmpi;
	RETI;
	NOP;

.org 2000;	-- codis set-segments
hex2ss0: .dw 0x3F;
hex2ss1: .dw 0x06;
hex2ss2: .dw 0x5B;
hex2ss3: .dw 0x4F;
hex2ss4: .dw 0x66;
hex2ss5: .dw 0x6D;
hex2ss6: .dw 0x7D;
hex2ss7: .dw 0x07;
hex2ss8: .dw 0x7F;
hex2ss9: .dw 0x67;
hex2ssA: .dw 0x5F;
hex2ssB: .dw 0x7C;
hex2ssC: .dw 0x58;
hex2ssD: .dw 0x5E;
hex2ssE: .dw 0x79;
hex2ssF: .dw 0x71;
hex2ssPD: .dw 0x80;
hex2ssU: .dw 0x3E;

.org 2025;	-- codis ASCII dels BCD
ascii0: .dw 0x30;
ascii1: .dw 0x31;
ascii2: .dw 0x32;
ascii3: .dw 0x33;
ascii4: .dw 0x34;
ascii5: .dw 0x35;
ascii6: .dw 0x36;
ascii7: .dw 0x37;
ascii8: .dw 0x38;
ascii9: .dw 0x39;
asciiA: .dw 0x41;
asciiB: .dw 0x42;
asciiC: .dw 0x43;
asciiD: .dw 0x44;
asciiE: .dw 0x45;
asciiF: .dw 0x46;
asciiLF: .dw 0x0A;
asciiCR: .dw 0x0D;
asciiPUNT: .dw 0x2E;


