--  PROGRAMA TRACTAMENT DE DADES Ftoc

.con posftoc0 = 0x000;		-> Posici guarda dada ftoc0 en memria
.con posftoc1 = 0x001;		-> Posici guarda dada ftoc1 en memria
.con posftoc2 = 0x002;		-> Posici guarda dada ftoc1 en memria
.con posftoc3 = 0x003;		-> Posici guarda dada ftoc1 en memria

.def sensor = 	R1;		-> Enumera sensor quan s'envia per uart
.def dada = 	R2;		-> Agafa la dada (del ftoc) que es tracta
.def nova = 	R3;		-> Actiu quan ha arribat nova dada
.def boto = 	R12;		-> Selecciona fotc a mostrar per SS
.def bituart0 = R13;		-> Guarda bit0 a enviar per uart
.def bituart1 = R14;		-> Guarda bit1 a enviar per uart
.def bituart2 = R15;		-> Guarda bit2 a enviar per uart
.def tmp = 	R20;
.def tmpi = 	R21;

.org 0;
	RJMP main;
.org 3;
	RJMP isrExt1dw ;	-> Noms es fa servir per comprovar funcionament
.org 16;
	RJMP isrFTOC0 ;
	RJMP isrFTOC1 ;
	RJMP isrFTOC2 ;
	RJMP isrFTOC3 ;
.org 32;
main:	LDI nova, 0;
	LDI boto, 0;
	OUT PORTB, boto;
	LDI X, hex2ssU;
	LPM tmp, X;
	OUT SS0, tmp;
	OUT SS1, tmp;
	OUT SS3, tmp;
	LDI X, hex2ssR;
	LPM tmp, X;
	OUT SS2, tmp;
	LDI tmp,0x0004;		-> Ctrl.Int.Ext. per selecci ftoc
	OUT ext0ctrl, tmp;
	LDI tmp,0x000C;		-> Ctrl.Uart:
	OUT uart0ctrl, tmp;		No interrupci, presc=12 (115200bauds-24MHz)
	RCALL inicialitzarFtocs;-> Inicialitzaci ftocs
	SEI;			-> Activaci interrupcions (BSET 0x7)	
retorn: CPI nova, 0;
	BRZE retorn;
	CLR nova;
	RCALL prepararUART;
	RCALL enviarCapUart;
	RCALL enviarAss;
	RJMP retorn;
	NOP;

inicialitzarFtocs: LDI tmp, 0x000;
	STS posftoc0, tmp;
	STS posftoc1, tmp;
	STS posftoc2, tmp;
	STS posftoc3, tmp;
	LDI tmp,0xC7D;		-> Ctrl.Ftoc. -> 1100 01111101
	OUT FTOC0ctrl, tmp;		ADDRCTRL_FTOC0
	OUT FTOC1ctrl, tmp;		ADDRCTRL_FTOC1
	OUT FTOC2ctrl, tmp;		ADDRCTRL_FTOC2
	OUT FTOC3ctrl, tmp;		ADDRCTRL_FTOC3
	RET;
	NOP;

.org 100;
enviarCapUart: LDI sensor, 0x30;-> Es tracta (ascii) sensor ftoc0
	LDS dada, posftoc0;	-> Agafar dada ftoc0 de memria dades
	RCALL tractarDadaUART;
	RCALL enviarDadaUart;

	LDI sensor, 0x31;	-> Es tracta (ascii) sensor ftoc1
	LDS dada, posftoc1;	-> Agafar dada ftoc1 de memria dades
	RCALL tractarDadaUART;
	RCALL enviarDadaUart;

	LDI sensor, 0x32;	-> Es tracta (ascii) sensor ftoc2
	LDS dada, posftoc2;	-> Agafar dada ftoc0 de memria dades
	RCALL tractarDadaUART;
	RCALL enviarDadaUart;

	LDI sensor, 0x33;	-> Es tracta (ascii) sensor ftoc3
	LDS dada, posftoc3;	-> Agafar dada ftoc1 de memria dades
	RCALL tractarDadaUART;
	RCALL enviarDadaUart;
	RET;
	NOP;
	
.org 150;
enviarAss: MOV tmp, boto;
	CPI boto, 0;
	BRNZ b1;
	LDS dada, posftoc0;	-> Agafar dada ftoc0 de memria dades
	RCALL dadaSS;
	RET;
b1:	CPI boto, 1;
	BRNZ b2;
	LDS dada, posftoc1;	-> Agafar dada ftoc0 de memria dades
	RCALL dadaSS;
	RET;
b2:	CPI boto, 2;
	BRNZ b3;
	LDS dada, posftoc2;	-> Agafar dada ftoc0 de memria dades
	RCALL dadaSS;
	RET;	
b3:	CPI boto, 3;
	BRNZ fiTest;
	LDS dada, posftoc3;	-> Agafar dada ftoc0 de memria dades
	RCALL dadaSS;
fiTest:	RET;

.org 200;
dadaSS: LDI X, 0x00F;		-> Tractament per SS bit menys significatiu
	AND X, dada;
	ADDI X, hex2ss0;
	LPM tmp, X;
	OUT SS0, tmp;
	SWAP dada;
	LDI X, 0x00F;		-> Tractament per SS bit ms significatiu
	AND X, dada;
	ADDI X, hex2ss0;
	LPM tmp, X;
	OUT SS1, tmp;
	SWAP dada;
	LDI X, 0x00F;		-> Tractament per SS bit prescalatge
	AND X, dada;
	ADDI X, hex2ss0;
	LPM tmp, X;
	OUT SS3, tmp;
	SWAP dada;		-> Restaura dada per tractament segent
	RET;

.org 250;
tractarDadaUart: LDI X, 0x00F;	-> Tractament per uart bit menys significatiu
	AND X, dada;
	ADDI X, ascii0;
	LPM bituart0, X;
	SWAP dada;
	LDI X, 0x00F;		-> Tractament per UART bit ms significatiu
	AND X, dada;
	ADDI X, ascii0;
	LPM bituart1, X;
	SWAP dada;
	LDI X, 0x00F;		-> Tractament per UART bit prescalatge
	AND X, dada;
	ADDI X, ascii0;
	LPM bituart2, X;
	SWAP dada;
	RET;

.org 300;
enviarDadaUart: NOP;
noBuit0: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit0;
	OUT uart0txd, sensor;	-> Treure sensor (0 o 1 o ...)
noBuit1: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit1;
	LDI tmp, 0x2E;		-> Treure punt
	OUT uart0txd, tmp;
noBuit2: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit2;
	OUT uart0txd, bituart2;	-> Bit prescaler
noBuit3: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit3;
	OUT uart0txd, bituart1;	-> Bit ms significatiu
noBuit4: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit4;
	OUT uart0txd, bituart0;	-> Bit menys significatiu
noBuit5: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit5;
	LDI tmp, 0x20;		-> Treure espai
	OUT uart0txd, tmp;
	RET;
	NOP;
		
prepararUART: NOP;
noBuit6: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit6;
	LDI tmp, 0x0D;		-> Treure CR
	OUT uart0txd, tmp;
noBuit7: IN tmp, uart0ctrl;
	ANDI tmp, 0x800;
	BRZE noBuit7;
	LDI tmp, 0x0A;		-> Treure LF
	OUT uart0txd, tmp;	
	RET;
	NOP;
	
----Rutina d'interrupci isrExt1down (canvia sensor que es mostra: 1 a 3)
.org 500;
isrExt1dw: SAVE;
	INC boto;
	ANDI boto, 0x003;
	OUT PORTB, boto;	-> Enviar a leds
	RESTORE;
	RETI;
	NOP;

--Rutina d'interrupci isrFTOC0
.org 525;
isrFTOC0: SAVE;
	IN tmpi, FTOC0;		->S'agafa dada de ftoc
	STS posftoc0, tmpi;
	INC nova;
	RESTORE;
	RETI;
	NOP;

--Rutina d'interrupci isrFTOC1
.org 550;
isrFTOC1: SAVE;
	IN tmpi, FTOC1;		->S'agafa dada de ftoc
	STS posftoc1, tmpi;
	INC nova;
	RESTORE;
	RETI;
	NOP;

--Rutina d'interrupci isrFTOC2
.org 575;
isrFTOC2: SAVE;
	IN tmpi, FTOC2;		->S'agafa dada de ftoc
	STS posftoc2, tmpi;
	INC nova;
	RESTORE;
	RETI;
	NOP;

--Rutina d'interrupci isrFTOC3
.org 600;
isrFTOC3: SAVE;
	IN tmpi, FTOC3;		->S'agafa dada de ftoc
	STS posftoc3, tmpi;
	INC nova;
	RESTORE;
	RETI;
	NOP;
	
.org 2000;	-- codis set-segments
hex2ss0: .dw 0x3F;
hex2ss1: .dw 0x06;
hex2ss2: .dw 0x5B;
hex2ss3: .dw 0x4F;
hex2ss4: .dw 0x66;
hex2ss5: .dw 0x6D;
hex2ss6: .dw 0x7D;
hex2ss7: .dw 0x07;
hex2ss8: .dw 0x7F;
hex2ss9: .dw 0x67;
hex2ssA: .dw 0x5F;
hex2ssB: .dw 0x7C;
hex2ssC: .dw 0x58;
hex2ssD: .dw 0x5E;
hex2ssE: .dw 0x79;
hex2ssF: .dw 0x71;
hex2ssPD: .dw 0x80;
hex2ssR: .dw 0x08;
hex2ssU: .dw 0x3E;

.org 2025;	-- codis ASCII dels BCD
ascii0: .dw 0x30;
ascii1: .dw 0x31;
ascii2: .dw 0x32;
ascii3: .dw 0x33;
ascii4: .dw 0x34;
ascii5: .dw 0x35;
ascii6: .dw 0x36;
ascii7: .dw 0x37;
ascii8: .dw 0x38;
ascii9: .dw 0x39;
asciiA: .dw 0x41;
asciiB: .dw 0x42;
asciiC: .dw 0x43;
asciiD: .dw 0x44;
asciiE: .dw 0x45;
asciiF: .dw 0x46;
asciiLF: .dw 0x0A;
asciiCR: .dw 0x0D;
asciiPUNT: .dw 0x2E;


